import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class Paquet {
	private ArrayList<Carte> listeCartes;
	public Paquet() {
		this.listeCartes = new ArrayList<Carte>();
		
	}

	// Ajout des 52 listeCartes au paquet
	public void createFullDeck() {
		// Generate Cards
		// parcours des couleurs
		for (Suit cardSuit : Suit.values()) {
			// parcours des valeurs
			for (Value cardValue : Value.values()) {
				// Add new card to the mix
				this.listeCartes.add(new Carte(cardSuit, cardValue));}
		}
	}

	// Shuffle deck of cards
	public void shuffle() {
		// Create a new arraylist to hold the shuffled cards temporarily
		ArrayList<Carte> tmpPaquet = new ArrayList<Carte>();
		// Randomly pick from the old deck and copy values to the new deck
		Random random = new Random();
		int randomCardIndex = 0;
		int originalSize = this.listeCartes.size();
		for (int i = 0; i < originalSize; i++) {
			// gen random num according to int randomNum = rand.nextInt((max -
			// min) + 1) + min;
			randomCardIndex = random.nextInt((this.listeCartes.size()-1 - 0) + 1) + 0;			// throw random card into new deck
			tmpPaquet.add(this.listeCartes.get(randomCardIndex));
			// remove picked from old deck
			this.listeCartes.remove(randomCardIndex);
		}
		// set this.deck to our newly shuffled deck
		this.listeCartes = tmpPaquet;
	}

	// Remove a card from the deck
	public void removeCard(int i) {
		this.listeCartes.remove(i);
	}

	// Get card from deck
	public Carte getCard(int i) {
		return this.listeCartes.get(i);
	}

	// Add card to deck
	public void addCard(Carte addCard) {
		this.listeCartes.add(addCard);
	}

	// Draw a top card from deck
	public void draw(Paquet comingFrom) {
		// Add card to this deck from whatever deck its coming from
		this.listeCartes.add(comingFrom.getCard(0));
		// Remove the card in the deck its coming from
		comingFrom.removeCard(0);
	}

	// Use to print out deck
	public String toString() {
		String cardListOutput = " ";
		int i = 0;
		for (Carte aCard : this.listeCartes) {
			cardListOutput += " " + aCard.toString();
			i++;
		}
		return cardListOutput;
	}

	public void moveAllToDeck(Paquet moveTo) {
		// put cards in moveTo deck
		for (int i = 0; i < this.listeCartes.size(); i++) {
			moveTo.addCard(this.getCard(i));
		}
		// empty out the deck
		for (int i = 0; i < this.listeCartes.size(); i++) {
			this.removeCard(0);
		}
	}

	public int deckSize() {
		return this.listeCartes.size();
	}

	// Calculate the value of deck
	public int cardsValue() {
		int totalValue = 0;
		int aces = 0;
		// For every card in the deck
		for (Carte aCard : this.listeCartes) {
			// Switch of possible values
			switch (aCard.getValeur()) {
			case DEUX:
				totalValue += 2;
				break;
			case TROIS:
				totalValue += 3;
				break;
			case QUATRE:
				totalValue += 4;
				break;
			case CINQ:
				totalValue += 5;
				break;
			case SIX:
				totalValue += 6;
				break;
			case SEPT:
				totalValue += 7;
				break;
			case HUIT:
				totalValue += 8;
				break;
			case NEUF:
				totalValue += 9;
				break;
			case DIX:
				totalValue += 10;
				break;
			case VALET:
				totalValue += 10;
				break;
			case REINE:
				totalValue += 10;
				break;
			case ROIS:
				totalValue += 10;
				break;
			case AS:
				aces += 1;
				break;
			}
		}

		// Determine the total current value with aces
		// Aces worth 11 or 1 - if 11 would go over 21 make it worth 1
		for (int i = 0; i < aces; i++) {
			// If they're already at over 10 getting an ace valued at 11 would
			// put them up to 22, so make ace worth one
			if (totalValue > 10) {
				totalValue += 1;
			} else {
				totalValue += 11;
			}
		}

		// Return
		return totalValue;

	}
}
